Index: lib/spatial/mapbuilder/examples/mergeModels/features.sld
===================================================================
--- lib/spatial/mapbuilder/examples/mergeModels/features.sld	(nonexistent)
+++ lib/spatial/mapbuilder/examples/mergeModels/features.sld	(revision 4307)
@@ -0,0 +1,174 @@
+<?xml version="1.0" encoding="utf-8" standalone="no" ?>
+<StyledLayerDescriptor version="1.0.0" xsi:schemaLocation="http://www.opengis.net/sld StyledLayerDescriptor.xsd" xmlns="http://www.opengis.net/sld" xmlns:ogc="http://www.opengis.net/ogc" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+	<!--
+    $Id: features.sld 3821 2008-02-01 13:58:30Z ahocevar $
+  -->
+	<NamedLayer>
+		<Name>gmlRenderer</Name>
+		<UserStyle>
+			<Name>defaultScenario</Name>
+			<IsDefault>true</IsDefault>
+			<FeatureTypeStyle>
+				<Rule>
+					<PointSymbolizer>
+						<Graphic>
+							<Mark>
+								<Fill>
+									<CssParameter name="fill">#AA0000</CssParameter>
+									<CssParameter name="fill-opacity">0.5</CssParameter>
+								</Fill>
+								<Stroke>
+									<CssParameter name="stroke">black</CssParameter>
+									<CssParameter name="stroke-opacity">1</CssParameter>
+									<CssParameter name="stroke-width">2</CssParameter>
+								</Stroke>
+							</Mark>
+							<Size>7</Size>
+						</Graphic>
+					</PointSymbolizer>
+					<LineSymbolizer>
+						<Stroke>
+							<CssParameter name="stroke">#AA0000</CssParameter>
+							<CssParameter name="stroke-opacity">0.5</CssParameter>
+							<CssParameter name="stroke-width">6</CssParameter>
+						</Stroke>
+					</LineSymbolizer>
+					<PolygonSymbolizer>
+						<Fill>
+							<CssParameter name="fill">#AA0000</CssParameter>
+							<CssParameter name="fill-opacity">0.5</CssParameter>
+						</Fill>
+						<Stroke>
+							<CssParameter name="stroke">black</CssParameter>
+							<CssParameter name="stroke-opacity">1</CssParameter>
+							<CssParameter name="stroke-width">3</CssParameter>
+						</Stroke>
+					</PolygonSymbolizer>
+				</Rule>
+			</FeatureTypeStyle>
+		</UserStyle>
+		<UserStyle>
+			<Name>selectedScenario</Name>
+			<FeatureTypeStyle>
+				<Rule>
+					<PointSymbolizer>
+						<Graphic>
+							<Mark>
+								<Fill>
+									<CssParameter name="fill">#FF2200</CssParameter>
+									<CssParameter name="fill-opacity">0.8</CssParameter>
+								</Fill>
+								<Stroke>
+									<CssParameter name="stroke">#FF4400</CssParameter>
+									<CssParameter name="stroke-opacity">0.8</CssParameter>
+									<CssParameter name="stroke-width">3</CssParameter>
+								</Stroke>
+							</Mark>
+							<Size>7</Size>
+						</Graphic>
+					</PointSymbolizer>
+					<LineSymbolizer>
+						<Stroke>
+							<CssParameter name="stroke">#FF2200</CssParameter>
+							<CssParameter name="stroke-opacity">0.8</CssParameter>
+							<CssParameter name="stroke-width">7</CssParameter>
+						</Stroke>
+					</LineSymbolizer>
+					<PolygonSymbolizer>
+						<Fill>
+							<CssParameter name="fill">#FF2200</CssParameter>
+							<CssParameter name="fill-opacity">0.8</CssParameter>
+						</Fill>
+						<Stroke>
+							<CssParameter name="stroke">#FF2200</CssParameter>
+							<CssParameter name="stroke-opacity">0.8</CssParameter>
+							<CssParameter name="stroke-width">7</CssParameter>
+						</Stroke>
+					</PolygonSymbolizer>
+				</Rule>
+			</FeatureTypeStyle>
+		</UserStyle>
+		<UserStyle>
+			<Name>defaultNews</Name>
+			<FeatureTypeStyle>
+				<Rule>
+					<PointSymbolizer>
+						<Graphic>
+							<Mark>
+								<Fill>
+									<CssParameter name="fill">#0000AA</CssParameter>
+									<CssParameter name="fill-opacity">0.5</CssParameter>
+								</Fill>
+								<Stroke>
+									<CssParameter name="stroke">red</CssParameter>
+									<CssParameter name="stroke-opacity">1</CssParameter>
+									<CssParameter name="stroke-width">2</CssParameter>
+								</Stroke>
+							</Mark>
+							<Size>7</Size>
+						</Graphic>
+					</PointSymbolizer>
+					<LineSymbolizer>
+						<Stroke>
+							<CssParameter name="stroke">#0000AA</CssParameter>
+							<CssParameter name="stroke-opacity">0.5</CssParameter>
+							<CssParameter name="stroke-width">6</CssParameter>
+						</Stroke>
+					</LineSymbolizer>
+					<PolygonSymbolizer>
+						<Fill>
+							<CssParameter name="fill">#0000AA</CssParameter>
+							<CssParameter name="fill-opacity">0.5</CssParameter>
+						</Fill>
+						<Stroke>
+							<CssParameter name="stroke">red</CssParameter>
+							<CssParameter name="stroke-opacity">1</CssParameter>
+							<CssParameter name="stroke-width">3</CssParameter>
+						</Stroke>
+					</PolygonSymbolizer>
+				</Rule>
+			</FeatureTypeStyle>
+		</UserStyle>
+		<UserStyle>
+			<Name>selectedNews</Name>
+			<FeatureTypeStyle>
+				<Rule>
+					<PointSymbolizer>
+						<Graphic>
+							<Mark>
+								<Fill>
+									<CssParameter name="fill">#FF2200</CssParameter>
+									<CssParameter name="fill-opacity">0.8</CssParameter>
+								</Fill>
+								<Stroke>
+									<CssParameter name="stroke">#FF2200</CssParameter>
+									<CssParameter name="stroke-opacity">0.8</CssParameter>
+									<CssParameter name="stroke-width">3</CssParameter>
+								</Stroke>
+							</Mark>
+							<Size>7</Size>
+						</Graphic>
+					</PointSymbolizer>
+					<LineSymbolizer>
+						<Stroke>
+							<CssParameter name="stroke">#FF2200</CssParameter>
+							<CssParameter name="stroke-opacity">0.8</CssParameter>
+							<CssParameter name="stroke-width">7</CssParameter>
+						</Stroke>
+					</LineSymbolizer>
+					<PolygonSymbolizer>
+						<Fill>
+							<CssParameter name="fill">#FF2200</CssParameter>
+							<CssParameter name="fill-opacity">0.8</CssParameter>
+						</Fill>
+						<Stroke>
+							<CssParameter name="stroke">#FF2200</CssParameter>
+							<CssParameter name="stroke-opacity">0.8</CssParameter>
+							<CssParameter name="stroke-width">7</CssParameter>
+						</Stroke>
+					</PolygonSymbolizer>
+				</Rule>
+			</FeatureTypeStyle>
+		</UserStyle>
+	</NamedLayer>
+</StyledLayerDescriptor>
Index: lib/spatial/mapbuilder/examples/mergeModels/FeatureList.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/mergeModels/FeatureList.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/mergeModels/FeatureList.xsl	(revision 4307)
@@ -0,0 +1,36 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:gml="http://www.opengis.net/gml" xmlns:pmb="http://nsuri.notld/poweredByMapbuilder" version="1.0">
+
+<!--
+$Id: FeatureList.xsl 3907 2008-03-06 10:27:06Z steven $
+-->
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+
+  <!-- Common params for all widgets -->
+  <!--xsl:param name="targetModelId"/-->
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="this">config.objects.<xsl:value-of select="$widgetId"/></xsl:param>
+
+  <!-- Main html -->
+  <xsl:template match="/">
+    <div>
+      <h3><xsl:value-of select="*/gml:name"/></h3>
+      <xsl:apply-templates/>
+    </div>
+  </xsl:template>
+
+  <xsl:template name="featureMember" match="gml:featureMember">
+    <xsl:param name="fid" select="*/@fid"/>
+    <div id="{$widgetId}_{$fid}" class="listitem" onmouseover="{$this}.highlight(this, '{$fid}')" onmouseout="{$this}.dehighlight(this, '{$fid}')">
+      <xsl:value-of select="*/pmb:date"/><br/>
+      <b><xsl:value-of select="*/pmb:name"/></b>
+    </div>
+  </xsl:template>
+
+  <!-- Remove documentation, text, comments -->
+  <xsl:template match="comment()|text()|processing-instruction()">
+  </xsl:template>
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/data/features.sld
===================================================================
--- lib/spatial/mapbuilder/examples/data/features.sld	(nonexistent)
+++ lib/spatial/mapbuilder/examples/data/features.sld	(revision 4307)
@@ -0,0 +1,92 @@
+<?xml version="1.0" encoding="utf-8" standalone="no" ?>
+<StyledLayerDescriptor version="1.0.0" xsi:schemaLocation="http://www.opengis.net/sld StyledLayerDescriptor.xsd" xmlns="http://www.opengis.net/sld" xmlns:ogc="http://www.opengis.net/ogc" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+	<!--
+    $Id: features.sld 3821 2008-02-01 13:58:30Z ahocevar $
+  -->
+	<NamedLayer>
+		<Name>testGmlRenderer</Name>
+		<UserStyle>
+			<Name>default</Name>
+			<IsDefault>true</IsDefault>
+			<FeatureTypeStyle>
+				<Rule>
+					<PointSymbolizer>
+						<Graphic>
+							<Mark>
+								<Fill>
+									<CssParameter name="fill">#FF00FF</CssParameter>
+									<CssParameter name="fill-opacity">0.8</CssParameter>
+								</Fill>
+								<Stroke>
+									<CssParameter name="stroke">black</CssParameter>
+									<CssParameter name="stroke-opacity">1</CssParameter>
+									<CssParameter name="stroke-width">2</CssParameter>
+								</Stroke>
+							</Mark>
+							<Size>4</Size>
+						</Graphic>
+					</PointSymbolizer>
+					<LineSymbolizer>
+						<Stroke>
+							<CssParameter name="stroke">#FF0000</CssParameter>
+							<CssParameter name="stroke-opacity">1</CssParameter>
+							<CssParameter name="stroke-width">3</CssParameter>
+						</Stroke>
+					</LineSymbolizer>
+					<PolygonSymbolizer>
+						<Fill>
+							<CssParameter name="fill">blue</CssParameter>
+							<CssParameter name="fill-opacity">0.6</CssParameter>
+						</Fill>
+						<Stroke>
+							<CssParameter name="stroke">blue</CssParameter>
+							<CssParameter name="stroke-opacity">1</CssParameter>
+							<CssParameter name="stroke-width">1</CssParameter>
+						</Stroke>
+					</PolygonSymbolizer>
+				</Rule>
+			</FeatureTypeStyle>
+		</UserStyle>
+		<UserStyle>
+			<Name>selected</Name>
+			<FeatureTypeStyle>
+				<Rule>
+					<PointSymbolizer>
+						<Graphic>
+							<Mark>
+								<Fill>
+									<CssParameter name="fill">yellow</CssParameter>
+									<CssParameter name="fill-opacity">0.9</CssParameter>
+								</Fill>
+								<Stroke>
+									<CssParameter name="stroke">red</CssParameter>
+									<CssParameter name="stroke-opacity">1</CssParameter>
+									<CssParameter name="stroke-width">2</CssParameter>
+								</Stroke>
+							</Mark>
+							<Size>4</Size>
+						</Graphic>
+					</PointSymbolizer>
+					<LineSymbolizer>
+						<Stroke>
+							<CssParameter name="stroke">yellow</CssParameter>
+							<CssParameter name="stroke-opacity">1</CssParameter>
+							<CssParameter name="stroke-width">3</CssParameter>
+						</Stroke>
+					</LineSymbolizer>
+					<PolygonSymbolizer>
+						<Fill>
+							<CssParameter name="fill">#FFFF00</CssParameter>
+							<CssParameter name="fill-opacity">0.9</CssParameter>
+						</Fill>
+						<Stroke>
+							<CssParameter name="stroke">#FF0066</CssParameter>
+							<CssParameter name="stroke-opacity">1</CssParameter>
+							<CssParameter name="stroke-width">2</CssParameter>
+						</Stroke>
+					</PolygonSymbolizer>
+				</Rule>
+			</FeatureTypeStyle>
+		</UserStyle>
+	</NamedLayer>
+</StyledLayerDescriptor>
Index: lib/spatial/mapbuilder/examples/contextEditor/owsCatSearchForm.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/contextEditor/owsCatSearchForm.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/contextEditor/owsCatSearchForm.xsl	(revision 4307)
@@ -0,0 +1,128 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!--
+Description: parses an listing of OGC services from the Discovery Portal registry
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: owsCatSearchForm.xsl 3907 2008-03-06 10:27:06Z steven $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+		xmlns:ogc="http://www.opengis.net/ogc"
+		xmlns:gml="http://www.opengis.net/gml"
+    xmlns:xlink="http://www.w3.org/1999/xlink">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <xsl:param name="modelTitle"/>
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="targetModelId"/>
+  <xsl:param name="targetModel"/>
+  <xsl:param name="lang">en</xsl:param>
+  
+  <xsl:param name="webServiceUrl">http://devgeo.cciw.ca/cgi-bin/mapserv/owscat</xsl:param>
+  <xsl:param name="formName">owsCatSearch</xsl:param>
+  <!-- NOTE: it's really bad form to put a hard-coded URL here, but it's the only way to use the document() function in IE -->
+  <!--xsl:param name="searchConfigDoc" select="document('http://demo.communitymapbuilder.org/mapbuilder-lib-1.0-release/demo/contextEditor/searchConfig.xml')"/-->  
+  <xsl:param name="searchConfigDoc" select="document('http://geodiscover.cgdi.ca/mapbuilder/demo/contextEditor/searchConfig.xml')"/>  
+  <xsl:param name="selectSize" select="1"/>
+  
+  <!-- Text params for this widget -->
+  <xsl:param name="north">North</xsl:param>
+  <xsl:param name="south">South</xsl:param>
+  <xsl:param name="east">East</xsl:param>
+  <xsl:param name="west">West</xsl:param>
+  
+  <!-- template rule matching source root element -->
+  <xsl:template match="/">
+    <div>
+    <h2>Search for layers</h2>
+    <form name="{$formName}" id="{$formName}" method="get">
+      <input type="hidden" name="version" value="1.0.0"/>
+      <input type="hidden" name="service" value="WFS"/>
+      <input type="hidden" name="request" value="GetFeature"/>
+      <input type="hidden" name="typename" value="service_resources"/>
+      <input type="hidden" name="outputFormat" value="GML3"/>
+      
+      <h3>Keywords</h3>
+      <input type="text" name="keywords"/>
+      <h3>Location</h3>
+      <xsl:call-template name="locations">
+        <xsl:with-param name="locationsDoc" select="$searchConfigDoc"/>
+      </xsl:call-template>
+      <xsl:call-template name="aoiBox"/>
+      <h3>Service Type</h3>
+      <select name="serviceType">
+        <option></option>
+        <option selected="true" value="OGC:WMS">WMS</option>
+        <option value="OGC:WFS">WFS</option>
+      </select>
+      <input class="button" type="reset"/>
+      <input class="button" type="submit"/>
+      
+    </form>
+    </div>
+  </xsl:template>
+
+  <xsl:template name="locations">
+    <xsl:param name="locationsDoc"/>
+    <div>
+      <select name="locations" onchange="config.objects.{$widgetId}.setLocation(this.options[this.selectedIndex].value);" size="{$selectSize}">
+        <xsl:apply-templates select="$locationsDoc/searchConfig[@entryType='productCollection']/locations/location"/>
+      </select>
+    </div>
+  </xsl:template>
+  
+  <xsl:template match="location">
+    <xsl:param name="indent"/>
+    <xsl:variable name="bbox" select="translate(wens,' ',',')"/>
+    <option value="{$bbox}"><xsl:value-of select="$indent"/><xsl:value-of select="title[@lang=$lang]"/></option>
+    <xsl:apply-templates select="location">
+      <xsl:with-param name="indent"><xsl:value-of select="$indent"/>&#160;&#160;</xsl:with-param>
+    </xsl:apply-templates>
+  </xsl:template>
+  
+  <xsl:template name="aoiBox">
+    <p>
+      <table>
+        <tr>
+          <td align="left">or enter</td>
+          <td><xsl:value-of select="$north"/></td>
+          <td><xsl:value-of select="$south"/></td>
+          <td><xsl:value-of select="$east"/></td>
+          <td><xsl:value-of select="$west"/></td>
+        </tr>
+        <tr>
+          <td>
+          </td>
+          <td>
+            <input name="northCoord" type="text" size="10" class="searchInput"/>
+          </td>
+          <td>
+            <input name="southCoord" type="text" size="10" class="searchInput"/>
+          </td>
+          <td>
+            <input name="eastCoord" type="text" size="10"  class="searchInput"/>
+          </td>
+          <td>
+            <input name="westCoord" type="text" size="10" class="searchInput"/>
+          </td>
+        </tr>
+      </table>
+    </p>
+  </xsl:template>
+  
+  <xsl:template name="ntsInput">
+    <p>or enter NTS mapsheet index
+      <input name="ntsIndex" type="text" size="6" class="searchInput"/>
+    </p>
+  </xsl:template>
+ 
+  <xsl:template match="text()|@*"/>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/contextEditor/Help.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/contextEditor/Help.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/contextEditor/Help.xsl	(revision 4307)
@@ -0,0 +1,37 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" xmlns:wmc="http://www.opengis.net/context" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" >
+
+<!--
+Description: Prototype stylesheet to automatically generate a form from an XML doc.
+Author:      Mike Adair
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+XmlForm.xsl,v 1.1 2004/06/28 03:46:49 madair1 Exp
+-->
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+
+  <!-- The common params set for all widgets -->
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+
+  <!-- The name of the form for coordinate output -->
+
+  <!-- Main html -->
+	<xsl:template match="/">
+    <div>
+    <h2>How to use this page</h2>
+      <ol>
+        <li>Start by selecting a map to use as your base map from the "Reference maps"</li>
+        <li>Search for WMS layers either from the seacrh form or by browsing a list of WMS servers in the "Search for data" menu</li>
+        <li>Add in layers of interest to your map</li>
+        <li>Add/remove/reorder layers using the "Layer control" tool in the "Edit Map Metadata" menu</li>
+        <li>Finally, when the map is ready to be saved, click on the"save" icon on the left side of the map.
+            This will save the map as a Web Map Context document which can be used in other applications.</li>
+      </ol>
+      </div>
+  </xsl:template>
+
+	<xsl:template match="text()|@*"/>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/Demis/CollectionList.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/Demis/CollectionList.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/Demis/CollectionList.xsl	(revision 4307)
@@ -0,0 +1,44 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!--
+Description: parses an OGC context collection document to generate a context pick list
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: CollectionList.xsl 2957 2007-07-09 12:21:10Z steven $
+$Name$
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:xlink="http://www.w3.org/1999/xlink"
+    exclude-result-prefixes="wmc xlink">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8"/>
+  <xsl:strip-space elements="*"/>
+
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang">en</xsl:param>
+
+  <!-- Text params for this widget -->
+  <xsl:param name="title"/>
+
+  <xsl:param name="widgetId"/>
+ 
+  <!-- template rule matching source root element -->
+  <xsl:template match="/wmc:ViewContextCollection">
+
+    <ul>
+      <xsl:apply-templates select="wmc:ViewContextReference"/>
+    </ul>
+
+  </xsl:template>
+
+  <xsl:template match="wmc:ViewContextReference">
+    <xsl:param name="linkUrl">config.objects.<xsl:value-of select="$widgetId"/>.switchMap(config.objects.<xsl:value-of select="$widgetId"/>,'<xsl:value-of select="wmc:ContextURL/wmc:OnlineResource/@xlink:href"/>')</xsl:param>
+    <xsl:param name="name"><xsl:value-of select='wmc:Title'/></xsl:param>
+    <input type='button' value="{$name}"  onClick="{$linkUrl}" />
+  </xsl:template>
+  
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/mergeModels/FeatureList.js
===================================================================
--- lib/spatial/mapbuilder/examples/mergeModels/FeatureList.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/mergeModels/FeatureList.js	(revision 4307)
@@ -0,0 +1,66 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: FeatureList.js 3733 2007-12-12 23:13:47Z ahocevar $
+*/
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Custom, read-only version of the FeatureList widget.
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @base WidgetBaseXSL
+ * @param widgetNode config node for this widget
+ * @param model parent model for this widget
+ */
+function FeatureList(widgetNode, model) {
+  WidgetBaseXSL.apply(this, arguments);
+
+  /**
+   * Listener function to highlight a list item when the mouse enters a
+   * feature on the map.
+   * @param objRef reference to this widget
+   */
+  this.highlightFeature = function(objRef) {
+    var fid = objRef.model.getParam("mouseoverFeature");
+    var highlightNode = document.getElementById(objRef.id+'_'+fid)
+    if (fid && highlightNode) {
+      highlightNode.className = 'listitem_active';
+    }
+  }
+  model.addListener("mouseoverFeature", this.highlightFeature, this);
+  
+  /**
+   * Listener function to dehighlight a list item when the mouse leaves a
+   * feature on the map.
+   * @param objRef reference to this widget
+   */
+  this.dehighlightFeature = function(objRef) {
+    var fid = objRef.model.getParam("mouseoutFeature");
+    var highlightNode = document.getElementById(objRef.id+'_'+fid)
+    if (fid && highlightNode) {
+      document.getElementById(objRef.id+'_'+fid).className = 'listitem';
+    }
+  }
+  model.addListener("mouseoutFeature", this.dehighlightFeature, this);
+  
+  /**
+   * Widget function to highlight the list item and call the listener that
+   * will highlight the feature in the map.
+   * @param div DOM node in the widget output that displays the feature
+   * @param fid feature id of the feature
+   */
+  this.highlight = function(div, fid) {
+    div.className="listitem_active";
+    model.setParam("highlightFeature", fid);
+  }
+  
+  /**
+   * Widget function to dehighlight the list item and call the listener that
+   * will hdeighlight the feature in the map.
+   * @param div DOM node in the widget output that displays the feature
+   * @param fid feature id of the feature
+   */
+  this.dehighlight = function(div, fid) {
+    div.className="listitem";
+    model.setParam("dehighlightFeature", fid);
+  }
+}
\ No newline at end of file
Index: lib/spatial/mapbuilder/examples/complete/complete.jsp
===================================================================
--- lib/spatial/mapbuilder/examples/complete/complete.jsp	(nonexistent)
+++ lib/spatial/mapbuilder/examples/complete/complete.jsp	(revision 4307)
@@ -0,0 +1,87 @@
+<%@page contentType="text/html"%>
+
+<!--
+Description: A Browser based Web Map Server Client based on javascript and XSL
+             libraries from http://mapbuilder.sourceforge.net .
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: complete.jsp 2124 2006-06-12 22:30:12Z lderezinski $
+$Name$
+-->
+<%
+  request.setAttribute("mbConfigUrl", "/demo/complete/completeConfig.xml");
+%>
+
+
+<html>
+  <head>
+    <title>Mapbuilder Demo</title>
+
+    <link rel="stylesheet" href="<%= request.getContextPath() %>/lib/skin/default/mapStyle.css" type="text/css">
+
+  <jsp:include page="/MapbuilderHead.jsp" flush="true"/>
+
+  </head>
+
+  <body onload="mbDoLoad()">
+    <!-- Layout mapbuilder widgets and HTML -->
+    <h1><a href="http://mapbuilder.sourceforge.net">Community Map Builder</a> Demo</h1>
+    <table>
+      <tr>
+        <td valign="top" style="padding:6px;width:180">
+        <div id="locatorMap" >  </div>
+        </td>
+        <td>
+          <h2 id="mapTitle"></h2>
+          <div id="mainMapPane"></div>
+        </td>
+      </tr>
+      <tr>
+        <td/>
+        <td valign="top">
+          <table width="100%">
+            <tr>
+              <td align="left">
+                <div id="mainButtonBar"/>
+              </td>
+              <td align="center" id="mapScaleText"/>
+              <td align="right" id="cursorTrack" />
+            </tr>
+          </table>
+        </td>
+      </tr>
+      <tr>
+        <td id="legend"/>
+        <td id="collectionList"/>
+      </tr>
+      <tr>
+        <td id="locationsSelect"/>
+        <td id="ntsLookupForm"/>
+      </tr>
+      <tr>
+        <td id="urlInput"/>
+        <td id="abstract"/>
+      </tr>
+      <tr>
+        <td id="saveModel"/>
+        <td id="wmsCapabilitiesImport"/>
+      </tr>
+      <tr>
+        <td/>
+        <td id="aoiForm"/>
+      </tr>
+      <tr>
+        <td id="featureList"/>
+        <td id="transactionResponse"/>
+      </tr>
+      <tr>
+        <td colspan="2">
+          <div id="eventLog"/>
+        </td>
+      </tr>
+    </table>
+    <br/>
+    <p align="right"><a href="http://mapbuilder.sourceforge.net">Community Map Builder</a><br/>$Name$</p>
+
+  </body>
+</html>
Index: lib/spatial/mapbuilder/examples/flickr/FlickrRest2Wfs.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/flickr/FlickrRest2Wfs.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/flickr/FlickrRest2Wfs.xsl	(revision 4307)
@@ -0,0 +1,65 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+  xmlns:wfs="http://www.opengis.net/wfs"
+  xmlns:gml="http://www.opengis.net/gml"
+  xmlns:dc="http://purl.org/dc/elements/1.1/" 
+  xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder"> 
+<!--
+Description: A stylesheet to convert flickr rest service to standards-compliant wfs.
+Author:      Andreas Hocevar andreas.hocevarATgmail.com
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: FlickrRest2Wfs.xsl 3728 2007-12-12 15:35:04Z ahocevar $
+-->
+
+  <xsl:param name="proxyUrl"/>
+  
+  <xsl:template match="rsp/photos">
+    <wfs:FeatureCollection xml:base="$proxyUrl">
+      <xsl:for-each select="photo">
+        <xsl:call-template name="featureMember"/>
+      </xsl:for-each>
+    </wfs:FeatureCollection>
+  </xsl:template>
+
+  <xsl:template name="featureMember">
+    <xsl:call-template name="point"/>
+  </xsl:template>
+
+<xsl:template name="point">
+  <xsl:param name="photouri"><xsl:value-of select="concat($proxyUrl,'?url=http%3A//www.flickr.com/services/rest/%3Fmethod%3Dflickr.photos.getInfo%26api_key%3Dafbacfb4d14cd681c04a06d69b24d847%26photo_id%3D',@id)"/></xsl:param>
+  <xsl:param name="photodoc" select="document($photouri)/rsp"/>
+  <xsl:variable name="lon">
+    <xsl:for-each select="$photodoc/photo/tags/tag">
+      <xsl:if test="substring-before(./@raw,'=')='geo:long'">
+        <xsl:value-of select="substring-after(./@raw,'=')"/>
+      </xsl:if>
+    </xsl:for-each>
+  </xsl:variable>
+  <xsl:variable name="lat">
+    <xsl:for-each select="$photodoc/photo/tags/tag">
+      <xsl:if test="substring-before(./@raw,'=')='geo:lat'">
+        <xsl:value-of select="substring-after(./@raw,'=')"/>
+      </xsl:if>
+    </xsl:for-each>
+  </xsl:variable>
+  <xsl:if test="$lat!=''">
+    <gml:featureMember>
+      <mb:geoRssFeature>
+        <xsl:attribute name="fid"><xsl:value-of select="./@id"/></xsl:attribute>
+        <mb:geom>
+          <gml:Point>
+            <gml:coordinates><xsl:value-of select="$lon"/>,<xsl:value-of select="$lat"/></gml:coordinates>
+          </gml:Point>
+        </mb:geom>
+        <mb:title><xsl:value-of select="$photodoc/photo/title"/></mb:title>
+        <mb:description><xsl:value-of select="$photodoc/photo/description"/></mb:description>
+        <dc:date><xsl:value-of select="$photodoc/photo/dates/@taken"/></dc:date>
+        <mb:url>http://static.flickr.com/<xsl:value-of select="./@server"/>/<xsl:value-of select="./@id"/>_<xsl:value-of select="./@secret"/>_s.jpg</mb:url>
+        <mb:photopage><xsl:value-of select="$photodoc/photo/urls/url[@type='photopage']"/></mb:photopage>
+      </mb:geoRssFeature>      
+    </gml:featureMember>
+  </xsl:if>
+</xsl:template>
+</xsl:stylesheet>
